<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: MAX7219.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MAX7219.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *    LedControl.h - A library for controling Leds with a MAX7219/MAX7221</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *    Copyright (c) 2007 Eberhard Fahle</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *    Permission is hereby granted, free of charge, to any person</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *    obtaining a copy of this software and associated documentation</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *    files (the &quot;Software&quot;), to deal in the Software without</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *    restriction, including without limitation the rights to use,</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *    copy, modify, merge, publish, distribute, sublicense, and/or sell</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *    copies of the Software, and to permit persons to whom the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *    Software is furnished to do so, subject to the following</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *    conditions:</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    This permission notice shall be included in all copies or</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    substantial portions of the Software.</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *    HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    OTHER DEALINGS IN THE SOFTWARE.</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifndef MAX7219_h</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#define MAX7219_h</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;SPI.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classMAX7219.html">   52</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMAX7219.html">MAX7219</a> {</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="classMAX7219.html#ad7a658d65e610e3e35fff96279bd5abe">MAX7219</a>(<a class="code" href="classSPI.html">SPI</a>* spi, <span class="keywordtype">int</span> numDevices = 1);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#ae21eeb2689755ebbd05b1df56e5bcca0">clearDisplay</a>(<span class="keywordtype">int</span> addr);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classMAX7219.html#a2765aed08c5ea70f43937c8b88d8b71a">getDeviceCount</a>();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a8a4624d45533a9de52585202f7b2fc78">setChar</a>(<span class="keywordtype">int</span> digit, <span class="keywordtype">char</span> value, <span class="keywordtype">bool</span> dp=<span class="keyword">false</span>, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a4cc8fe7ad21942e059ac4a931fce502e">setColumn</a>(<span class="keywordtype">int</span> col, uint8_t value, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#aa4f94d965ecde62d2dd8a4091005b0a0">setDigit</a>(<span class="keywordtype">int</span> digit, uint8_t value, <span class="keywordtype">bool</span> dp=<span class="keyword">false</span>, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a204133a6b253f5d519acd5dc0077f32a">setIntensity</a>(<span class="keywordtype">int</span> intensity, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#aebc8bfad65290b1b4580688c719f7e13">setLed</a>(<span class="keywordtype">int</span> row, <span class="keywordtype">int</span> col, <span class="keywordtype">bool</span> state, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a1e50065060426b3433ec16ea2e304760">setNumber</a>(uint32_t number, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#aecd0b20a63757fd74e849369dd797e74">setRow</a>(<span class="keywordtype">int</span> row, uint8_t value, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a14cd47938ff60879b676d9a0c02d4268">setScanLimit</a>(<span class="keywordtype">int</span> limit, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMAX7219.html#a948326a74baa10f8fead88c7b04a21b1">shutdown</a>(<span class="keywordtype">bool</span> status, <span class="keywordtype">int</span> addr = 0);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="comment">/* Send out a single command to the device */</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">void</span> spiTransfer(<span class="keywordtype">int</span> addr, uint8_t opcode, uint8_t data);</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="comment">/* We keep track of the led-status for all 8 devices in this array */</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    uint8_t status[64];</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="comment">/* The maximum number of devices we use */</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordtype">int</span> maxDevices;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <a class="code" href="classSPI.html">SPI</a>* spi;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;};</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="preprocessor">#endif  // MAX7219.h</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="ttc" id="classMAX7219_html"><div class="ttname"><a href="classMAX7219.html">MAX7219</a></div><div class="ttdoc">MAX7219 and MAX7221 controller.</div><div class="ttdef"><b>Definition:</b> MAX7219.h:52</div></div>
<div class="ttc" id="classMAX7219_html_a1e50065060426b3433ec16ea2e304760"><div class="ttname"><a href="classMAX7219.html#a1e50065060426b3433ec16ea2e304760">MAX7219::setNumber</a></div><div class="ttdeci">void setNumber(uint32_t number, int addr=0)</div><div class="ttdoc">Display a number on the 7-Segment display.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:238</div></div>
<div class="ttc" id="classMAX7219_html_a2765aed08c5ea70f43937c8b88d8b71a"><div class="ttname"><a href="classMAX7219.html#a2765aed08c5ea70f43937c8b88d8b71a">MAX7219::getDeviceCount</a></div><div class="ttdeci">int getDeviceCount()</div><div class="ttdoc">Gets the number of devices attached to this MAX7219.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:103</div></div>
<div class="ttc" id="classSPI_html"><div class="ttname"><a href="classSPI.html">SPI</a></div><div class="ttdoc">Handle SPI protocol.</div><div class="ttdef"><b>Definition:</b> SPI.h:15</div></div>
<div class="ttc" id="classMAX7219_html_ad7a658d65e610e3e35fff96279bd5abe"><div class="ttname"><a href="classMAX7219.html#ad7a658d65e610e3e35fff96279bd5abe">MAX7219::MAX7219</a></div><div class="ttdeci">MAX7219(SPI *spi, int numDevices=1)</div><div class="ttdoc">Create a new MAX7219 controller.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:79</div></div>
<div class="ttc" id="classMAX7219_html_a4cc8fe7ad21942e059ac4a931fce502e"><div class="ttname"><a href="classMAX7219.html#a4cc8fe7ad21942e059ac4a931fce502e">MAX7219::setColumn</a></div><div class="ttdeci">void setColumn(int col, uint8_t value, int addr=0)</div><div class="ttdoc">Set all 8 Led's in a column to a new state.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:178</div></div>
<div class="ttc" id="classMAX7219_html_a14cd47938ff60879b676d9a0c02d4268"><div class="ttname"><a href="classMAX7219.html#a14cd47938ff60879b676d9a0c02d4268">MAX7219::setScanLimit</a></div><div class="ttdeci">void setScanLimit(int limit, int addr=0)</div><div class="ttdoc">Set the number of digits (or rows) to be displayed. See datasheet for side effects of the scanlimit o...</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:119</div></div>
<div class="ttc" id="classMAX7219_html_aebc8bfad65290b1b4580688c719f7e13"><div class="ttname"><a href="classMAX7219.html#aebc8bfad65290b1b4580688c719f7e13">MAX7219::setLed</a></div><div class="ttdeci">void setLed(int row, int col, bool state, int addr=0)</div><div class="ttdoc">Set the status of a single Led.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:147</div></div>
<div class="ttc" id="classMAX7219_html_a948326a74baa10f8fead88c7b04a21b1"><div class="ttname"><a href="classMAX7219.html#a948326a74baa10f8fead88c7b04a21b1">MAX7219::shutdown</a></div><div class="ttdeci">void shutdown(bool status, int addr=0)</div><div class="ttdoc">Set the shutdown (power saving) mode for the device.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:108</div></div>
<div class="ttc" id="classMAX7219_html_aa4f94d965ecde62d2dd8a4091005b0a0"><div class="ttname"><a href="classMAX7219.html#aa4f94d965ecde62d2dd8a4091005b0a0">MAX7219::setDigit</a></div><div class="ttdeci">void setDigit(int digit, uint8_t value, bool dp=false, int addr=0)</div><div class="ttdoc">Display a hexadecimal digit on a 7-Segment Display.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:191</div></div>
<div class="ttc" id="classMAX7219_html_a8a4624d45533a9de52585202f7b2fc78"><div class="ttname"><a href="classMAX7219.html#a8a4624d45533a9de52585202f7b2fc78">MAX7219::setChar</a></div><div class="ttdeci">void setChar(int digit, char value, bool dp=false, int addr=0)</div><div class="ttdoc">Display a character on a 7-Segment display.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:205</div></div>
<div class="ttc" id="classMAX7219_html_aecd0b20a63757fd74e849369dd797e74"><div class="ttname"><a href="classMAX7219.html#aecd0b20a63757fd74e849369dd797e74">MAX7219::setRow</a></div><div class="ttdeci">void setRow(int row, uint8_t value, int addr=0)</div><div class="ttdoc">Set all 8 Led's in a row to a new state.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:168</div></div>
<div class="ttc" id="classMAX7219_html_a204133a6b253f5d519acd5dc0077f32a"><div class="ttname"><a href="classMAX7219.html#a204133a6b253f5d519acd5dc0077f32a">MAX7219::setIntensity</a></div><div class="ttdeci">void setIntensity(int intensity, int addr=0)</div><div class="ttdoc">Set the brightness of the display.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:127</div></div>
<div class="ttc" id="classMAX7219_html_ae21eeb2689755ebbd05b1df56e5bcca0"><div class="ttname"><a href="classMAX7219.html#ae21eeb2689755ebbd05b1df56e5bcca0">MAX7219::clearDisplay</a></div><div class="ttdeci">void clearDisplay(int addr)</div><div class="ttdoc">Switch all Leds on the display off.</div><div class="ttdef"><b>Definition:</b> MAX7219.cpp:135</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
